#include <glib.h>

#include <utillib.h>

#include "gdownman-marshal.h"

#include "project-settings.h"


GType           project_settings_get_type           ();
static void     project_settings_class_init         (ProjectSettingsClass *klass);
static void     project_settings_init               (ProjectSettings *project_settings);

enum {
    LAST_SIGNAL
};

static gint project_settings_signals[LAST_SIGNAL] = { 0 };

static gpointer parent_class = NULL;


GType
project_settings_get_type ()
{
    static GType project_settings_type = 0;

    if (!project_settings_type)
    {
        static const GTypeInfo project_settings_info =
        {
            sizeof (ProjectSettingsClass),
            (GBaseInitFunc) NULL,
            (GBaseFinalizeFunc) NULL,
            (GClassInitFunc) project_settings_class_init,
            NULL,           /* class_finalize */
            NULL,           /* class_data */
            sizeof (ProjectSettings),
            0,              /* n_preallocs */
            (GInstanceInitFunc) project_settings_init
        };

        project_settings_type = g_type_register_static (G_TYPE_OBJECT,
                                               "ProjectSettings",
                                               &project_settings_info,
                                               0);
    }

    return project_settings_type;
}

static void
project_settings_class_init (ProjectSettingsClass *klass)
{
    parent_class = g_type_class_peek_parent (klass);
}

static void
project_settings_init (ProjectSettings *project_settings)
{
    project_settings->id = 666;
    project_settings->path = 0;
    project_settings->automatic_download = 1;
    project_settings->maxdownloads = 1;
}

ProjectSettings *
project_settings_new ()
{
    ProjectSettings *project_settings = PROJECT_SETTINGS (g_object_new (project_settings_get_type (), NULL));

	return project_settings;
}

void
project_settings_id_set (ProjectSettings *project_settings, guint id)
{
    project_settings->id = id;
}

guint
project_settings_id_get (ProjectSettings *project_settings)
{
    return project_settings->id;
}

void
project_settings_path_set (ProjectSettings *project_settings,
    const gchar *path)
{
    project_settings->path = g_strdup (path);
}

const gchar *
project_settings_path_get (ProjectSettings *project_settings)
{
    return project_settings->path;
}

void
project_settings_autodownload_set (ProjectSettings *project_settings,
    guint auto_download)
{
    project_settings->automatic_download = auto_download;
}

guint
project_settings_autodownload_get (ProjectSettings *project_settings)
{
    return project_settings->automatic_download;
}

void
project_settings_maxdownloads_set (ProjectSettings *project_settings,
    guint max_downloads)
{
    project_settings->maxdownloads = max_downloads;
}

guint
project_settings_maxdownloads_get (ProjectSettings *project_settings)
{
    return project_settings->maxdownloads;
}
