#ifndef __SERVERS_H__
#define __SERVERS_H__

#include <glib-object.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


#define SERVERS(obj)           G_TYPE_CHECK_INSTANCE_CAST (obj, servers_get_type (), Servers)
#define SERVERS_CLASS(klass)   G_TYPE_CHECK_CLASS_CAST (klass, servers_get_type (), ServersClass)
#define IS_SERVERS(obj)        G_TYPE_CHECK_INSTANCE_TYPE (obj, servers_get_type ())


typedef struct _Servers        Servers;
typedef struct _ServersClass   ServersClass;

struct _Servers
{
    GObject object;

    /*< private >*/
    GtkWidget *dialog;
    GtkWidget *vbox;
    GtkTreeView *tree_view;
    GtkTreeSelection *selection;
    GtkWidget *properties_button;
    GtkWidget *properties_dialog;
    GtkWidget *max_conn_spin;
    GtkWidget *max_conn_check;

    GtkTreeModel *model;

    /* Settings */
    gboolean active;
    guint fd;
};

struct _ServersClass
{
    GObjectClass parent_class;
};

GType       servers_get_type    (void);
Servers*    servers_new         (guint fd, GtkWindow *parent);

void    servers_start           (Servers *servers);
void    servers_add             (Servers *servers, gchar *name, gint max,
                                 guint current);

void    servers_max_connections     (Servers *servers, gchar *name, gint max);
void    servers_current_connections (Servers *servers, gchar *name,
                                     guint current);

void    servers_sensitive_set   (Servers *servers, gboolean setting);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* __SERVERS_H__ */
