#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <pwd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include <glib.h>

#include <utillib.h>

#include "debug.h"

int debug_log_file;

void debug_log (const gchar *log_domain, GLogLevelFlags log_level,
		const gchar *message, gpointer user_data);

void debug_open_log()
{
	GString *buffer = g_string_new(NULL);

    g_string_printf (buffer, "%s/.downman/debug_log.txt", g_get_home_dir ());
	debug_log_file = open(buffer->str, O_WRONLY | O_CREAT | O_APPEND, S_IREAD | S_IWRITE);
	g_string_free(buffer, TRUE);
	if (debug_log_file == -1)
	{
		perror("can't create log file");
		exit(1);
	}

	g_log_set_handler (NULL, G_LOG_LEVEL_DEBUG | G_LOG_FLAG_FATAL
						| G_LOG_FLAG_RECURSION, debug_log, NULL);

}

void debug_close_log()
{
	if (close(debug_log_file) == -1)
		perror("can't close log file");
}

void debug_log (const gchar *log_domain, GLogLevelFlags log_level,
		const gchar *message, gpointer user_data)
{
	write(debug_log_file, message, strlen(message));
}
