
GString *   dm_command_get_new          (guint project, const gchar *url);
void    dm_command_get_set_localpath    (GString *item, const gchar *localpath);
void    dm_command_get_set_stop         (GString *item, gboolean stop);
void    dm_command_get_set_recursive    (GString *item, guint recursive);
void    dm_command_get_set_speed        (GString *item, guint speed);
gint    dm_command_get                  (GString *item, guint fd);

void    dm_command_download_set_speed   (gint fd, guint project, guint download,
                                         guint speed);

gint    dm_command_download_start   (gint fd, guint project, guint download);
gint    dm_command_download_stop    (gint fd, guint project, guint download);
gint    dm_command_download_queue   (gint fd, guint project, guint download);
gint    dm_command_download_delete  (gint fd, guint project, guint download);

gint    dm_command_server_events    (gint fd, guint receive);
gint    dm_command_server_max_connections   (gint fd, gchar *server,
                                             gint max_conn);

GString *   dm_command_project_create_new   (const gchar *name,
                                             const gchar *path);
void    dm_command_project_create_auto      (GString *item, guint setting);
void    dm_command_project_create_set_speed (GString *item, guint speed);
gint    dm_command_project_create   (GString *item, guint fd);

gint    dm_command_project_delete   (gint fd, guint project);
gint    dm_command_batchstatus      (gint fd, guint time, const char *batch);
gint    dm_command_batchprogress    (gint fd, guint time, const char *batch);
gint    dm_command_events           (gint fd, guint receive, const char *batch);
gint    dm_command_projects_events  (gint fd, guint receive);
gint    dm_command_auto             (gint fd, guint project, guint setting);
gint    dm_command_maxdownloads     (gint fd, guint project,
                                     guint maxdownloads);

enum dm_command_ids
{
    DM_COMMAND_ITEM_NEW = 100,
    DM_COMMAND_ITEM_DELETE,
    DM_COMMAND_ITEM_START,
    DM_COMMAND_ITEM_STOP,
    DM_COMMAND_ITEM_PAUSE,
    DM_COMMAND_ITEM_QUEUE,
    DM_COMMAND_ITEM_DONE,
    DM_COMMAND_ITEM_URL,
    DM_COMMAND_ITEM_PATH,
    DM_COMMAND_ITEM_RECURSIVE,
    DM_COMMAND_ITEM_SPEED,

    DM_COMMAND_SERVER_NEW = 200,
    DM_COMMAND_SERVER_DELETE,
    DM_COMMAND_SERVER_EVENTS,
    DM_COMMAND_SERVER_MAX_CONNECTIONS,
    DM_COMMAND_SERVER_CURRENT_CONNECTIONS,

    DM_COMMAND_BATCH_STATUS = 300,
    DM_COMMAND_BATCH_PROGRESS,

    DM_COMMAND_PROJECT_NEW = 400,
    DM_COMMAND_PROJECT_DELETE,
    DM_COMMAND_PROJECT_NAME,
    DM_COMMAND_PROJECT_PATH,
    DM_COMMAND_PROJECT_AUTO,
    DM_COMMAND_PROJECT_MAXTRANSFERS,
    DM_COMMAND_PROJECT_SPEED,

    DM_COMMAND_CONFIG_NAME = 500,
    DM_COMMAND_CONFIG_EVENTS,
    DM_COMMAND_CONFIG_PROJECT_EVENTS,
    DM_COMMAND_CONFIG_BATCHSTATUS,
    DM_COMMAND_CONFIG_BATCHPROGRESS,

    DM_COMMAND_ERROR = 600,

    DM_COMMAND_SHUTDOWN = 900
};

enum dm_transfer_status
{
	STATUS_DONE = 0,

	STATUS_STOPPING,
	STATUS_STOPPED,
	STATUS_QUEUED,
	STATUS_INIT,
	STATUS_STARTING,
	STATUS_RESOLVING,
	STATUS_CONNECTING,
	STATUS_WAITING_DATA,
	STATUS_LOGIN,
	STATUS_TRANSFERING,

	ERROR_FIRST,

	ERROR_OPENING_SOURCE,
	ERROR_OPENING_TARGET,
	ERROR_CREATING_SOCKET,
	ERROR_RESOLVING,
	ERROR_CONNECTING,
	ERROR_LOGIN,
	ERROR_GETTING_HEAD,
	ERROR_GETTING_DATA,
	ERROR_NOT_COMPLETE,
    ERROR_READING_SOURCE,
    ERROR_WRITING_TARGET,

	ERROR_LAST
};

const gchar *dm_transfer_status_string (enum dm_transfer_status status);
